<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/22/2004 *
 * ================                             Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-extentions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Extension management                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Erweiterungen-Management                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Normally we want the overview of all registered extensions
$do = 'overview';
$SEL = 0;

// Are some extensions submitted?
if (isPostRequestElementSet('sel')) {
	// Then count all
	$SEL = countPostSelection();
} // END - if

if (isGetRequestElementSet('reg_ext')) {
	// We are about to register a new extension
	$do = 'register'; $ext_id = bigintval(getRequestElement('reg_ext'));
	// The ID comes from task management and it is - of course - *not* the extension's name!
} elseif ((isPostRequestElementSet('change')) && ($SEL > 0) && (!isDemoModeActive())) {
	// De-/activate extensions
	foreach (postRequestElement('sel') as $ext_id => $active) {
		// Shall we keep the extension always active?
		if ((isset($GLOBALS['cache_array']['active_extensions'][getExtensionName($ext_id)])) && ($GLOBALS['cache_array']['active_extensions'][getExtensionName($ext_id)] == 'Y') && ($active != 'Y')) {
			// Keep this extension active!
		} else {
			// De/activate extension
			$ACT = 'N'; getExtensionMode('deactivate');
			if ($active != 'Y') { $ACT = 'Y'; setExtensionMode('activate'); }
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_extensions` SET `ext_active`='".$ACT."' WHERE `id`=%s AND `ext_active`='%s' LIMIT 1",
			array(bigintval($ext_id), $active), __FILE__, __LINE__);

			// Run embeded SQL commands
			doExtensionSqls($ext_id, getExtensionMode());
		}
	}
} elseif (((isPostRequestElementSet('edit')) || (isPostRequestElementSet(('modify')))) && ($SEL > 0) && (!isDemoModeActive())) {
	// Change settings like CSS file load
	if (isPostRequestElementSet(('modify'))) {
		// Change entries
		$cache_update = 0;
		foreach (postRequestElement('sel') as $ext_id => $sel) {
			// Secure ID
			$ext_id = bigintval($ext_id);

			// Change this extension?
			if ($sel == 1) {
				// Load mode is modify
				getExtensionMode('modify');

				// Get entry for 'active'
				$active = postRequestElement('active', $ext_id);

				// Update extension's record
				if (getExtensionVersion('sql_patches') >= '0.0.6') {
					// Update also CSS column when extensions sql_patches is newer or exact v0.0.6
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_extensions` SET `ext_has_css`='%s', `ext_active`='%s' WHERE `id`=%s LIMIT 1",
						array(postRequestElement('css', $ext_id), $active, $ext_id), __FILE__, __LINE__);
				} else {
					// When extension is older than v0.0.6 there is no column for the CSS information
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_extensions` SET `ext_active`='%s' WHERE `id`=%s LIMIT 1",
						array($active, $ext_id), __FILE__, __LINE__);
				}

				// Run SQLs on activation / deactivation
				switch ($active) {
					case 'Y': setExtensionMode('activate');   break;
					case 'N': setExtensionMode('deactivate'); break;
				} // END - if

				// Run embeded SQL commands
				doExtensionSqls($ext_id, getExtensionMode());
			}
		}

		// Extensions changed
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_EXT_CHANGED'));
	} else {
		// Edit selected entries
		$SW = 2; $OUT = '';
		foreach (postRequestElement('sel') as $ext_id => $sel) {
			// Edit this extension?
			if (($sel == 'Y') || ($sel != 'Y')) {
				// Default is no CSS for non-updated mailers
				$css = 'N';

				// Load required data
				if (getExtensionVersion('sql_patches') >= '0.0.6') {
					$result = SQL_QUERY_ESC("SELECT ext_has_css, ext_active FROM `{?_MYSQL_PREFIX?}_extensions` WHERE `id`=%s LIMIT 1",
						array(bigintval($ext_id)), __FILE__, __LINE__);
					list($css, $active) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
				} else {
					$result = SQL_QUERY_ESC("SELECT ext_active FROM `{?_MYSQL_PREFIX?}_extensions` WHERE `id`=%s LIMIT 1",
						array(bigintval($ext_id)), __FILE__, __LINE__);
					list($active) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
					$css = 'X';
				}

				// Output row
				$cssSelection = '---';
				if (getExtensionVersion('sql_patches') >= '0.0.6') $cssSelection = addSelectionBox('yn', $css, 'css', $ext_id);

				// Prepare data for the row template
				$content = array(
					'sw'     => $SW,
					'id'     => $ext_id,
					'name'   => getExtensionName($ext_id),
					'active' => addSelectionBox('yn', $active, 'active', $ext_id),
					'css'    => $cssSelection,
				);

				// Load row template and switch color
				$OUT .= loadTemplate('admin_extensions_edit_row', true, $content);
				$SW = 3 - $SW;
			}
		} // END - foreach

		// Load template
		loadTemplate('admin_extensions_edit', false, $OUT);
		$do = 'edit';
	}
} elseif ((isPostRequestElementSet('delete')) && ($SEL > 0) && (!isDemoModeActive())) {
	// List extensions and when verbose is enabled SQL statements which will be executed
	$OUT = ''; $SW = 2;
	foreach (postRequestElement('sel') as $ext_id => $sel) {
		// Init variables
		$VERBOSE_OUT = '';
		initSqls();

		// Secure id number
		$ext_id = bigintval($ext_id);

		// Is the id valid?
		if (isExtensionIdValid($ext_id)) {
			// Get extension name
			$ext_name = getExtensionName($ext_id);

			if (getConfig('verbose_sql') == 'Y') {
				// Load SQL commands in remove mode
				if (loadExtension($ext_name, 'remove', '', true)) {
					// Generate extra table with loaded SQL commands
					$VERBOSE_OUT = addExtensionVerboseSqlTable();
				} // END - if
			} // END - if

			// Prepare data for the row template
			$content = array(
				'sw'       => $SW,
				'id'       => $ext_id,
				'ext_name' => $ext_name,
				'ext_ver'  => getExtensionVersion($ext_name),
				'verbose'  => $VERBOSE_OUT
			);

			// Load row template and switch color
			$OUT .= loadTemplate('admin_extensions_delete_row', true, $content);
		} else {
			// Prepare data for the row template
			$content = array(
				'sw'       => $SW,
				'id'       => $ext_id
			);

			// Not valid!
			$OUT .= loadTemplate('admin_extensions_delete_row_404', true, $content);
		}
		$SW = 3 - $SW;
	} // END - foreach

	// Load template
	loadTemplate('admin_extensions_delete', false, $OUT);
	$do = 'delete';
} elseif ((isPostRequestElementSet('remove')) && ($SEL > 0) && (!isDemoModeActive())) {
	// Remove extensions from DB (you have to delete all files manually!)
	$cache_update = 0;
	foreach (postRequestElement('sel') as $ext_id => $active) {
		// Secure ID number
		$ext_id = bigintval($ext_id);

		// Is this extension selected and id valid?
		if (($active == 1) && (isExtensionIdValid($ext_id))) {
			// Run embeded SQL commands
			doExtensionSqls($ext_id, 'remove');
		} // END - if
	} // END - foreach

	// Extensions removed
	loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_EXTENSIONS_REMOVED'), $SEL));
} elseif ((isGetRequestElementSet('do')) && (!isDemoModeActive())) {
	// Other things to do
	$do = SQL_ESCAPE(secureString(getRequestElement('do')));
} elseif (isGetRequestElementSet('do')) {
	// Demo mode active!
	$do = 'demo';
}

// Shall we display active/inactive extensions?
$where = '';
if (isGetRequestElementSet(('active'))) {
	$where = sprintf("WHERE `ext_active`='%s'", SQL_ESCAPE(secureString(getRequestElement('active'))));
} // END - if

// Case selection
switch ($do) {
	case 'overview': // List all registered extensions
		if (isExtensionInstalledAndNewer('sql_patches', '0.0.6')) {
			// Load extension data with CSS informations
			$result = SQL_QUERY("SELECT `id` AS ext_id, `ext_name`, `ext_active`, `ext_has_css` AS ext_css, `ext_version`
FROM `{?_MYSQL_PREFIX?}_extensions`
".$where."
ORDER BY `ext_name` ASC", __FILE__, __LINE__);
		} else {
			// Load extension data without CSS informations
			$result = SQL_QUERY("SELECT `id` AS ext_id, `ext_name`, `ext_active`, `id`, `ext_version`
FROM `{?_MYSQL_PREFIX?}_extensions`
".$where."
ORDER BY `ext_name` ASC", __FILE__, __LINE__);
		}

		// Are there some entries?
		if (SQL_NUMROWS($result) > 0) {
			// Extensions are registered
			$OUT = ''; $SW = 2;
			while ($content = SQL_FETCHARRAY($result)) {
				// Prepare CSS selection output
				$cssSelection = '---';
				if (getExtensionVersion('sql_patches') >= '0.0.6') $cssSelection = translateYesNo($content['ext_css']);

				// Prepare data for the row template
				$content = array(
					'sw'      => $SW,
					'id'      => $content['ext_id'],
					'name'    => $content['ext_name'],
					'active'  => translateYesNo($content['ext_active']),
					'act_val' => $content['ext_active'],
					'css'     => $cssSelection,
					'ver'     => $content['ext_version'],
				);

				// Load row template and switch color
				$OUT .= loadTemplate('admin_extensions_row', true, $content);
				$SW = 3 - $SW;
			}

			// Free memory
			SQL_FREERESULT($result);

			// Load template
			loadTemplate('admin_extensions', false, $OUT);
		} else {
			// No extensions are registered
			loadTemplate('admin_settings_saved', false, getMessage('ADMIN_NO_EXTENSION_REGISTERED'));
		}
		break;

	case 'register': // Register new extension
		$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_task_system` WHERE `assigned_admin`=%s AND `task_type`='EXTENSION' LIMIT 1",
			array(getCurrentAdminId()), __FILE__, __LINE__);
		$task_found = SQL_NUMROWS($result);

		// Free result
		SQL_FREERESULT($result);

		// Is the ID number valid and the task was found?
		if (($ext_id > 0) && ($task_found == 1)) {
			// ID is valid so begin with registration, we first want to it's real name from task management (subject column)
			$result = SQL_QUERY_ESC("SELECT `subject` FROM `{?_MYSQL_PREFIX?}_task_system` WHERE `id`=%s LIMIT 1",
				array(bigintval($ext_id)), __FILE__, __LINE__);
			list($subj) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Disable cache update by default
			$cache_update = 0;
			if (!empty($subj)) {
				// Extract extension's name from subject...
				$ext_name = trim(substr($subj, 1, strpos($subj, ':') - 1));

				// Test the extension for deprecation
				loadExtension($ext_name, 'test');

				// Is the extension deprecated?
				if (!isExtensionDeprecated()) {
					// ... so we can finally register and load it in registration mode
					if (registerExtension($ext_name, $ext_id)) {
						// Errors?
						if (getTotalFatalErrors() == 0) {
							// Extension was found and successfully registered
							loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_EXTENSION_REGISTERED'), $ext_name));

							// Show next link
							if (isExtensionActive('task')) {
								loadTemplate('admin_next_link', false, array(
									'url'   => 'modules.php?module=admin&amp;what=list_task',
									'title' => getMessage('ADMIN_EXT_REGISTER_NEXT_LINK')
								));
							} else {
								loadTemplate('admin_next_link', false, array(
									'url'   => 'modules.php?module=admin',
									'title' => getMessage('ADMIN_EXT_REGISTER_NEXT_LINK')
								));
							}
						} else {
							// Errors detected!
							loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_EXTENSION_NOT_REGISTERED'), $ext_name));
						}

						// Do we need to update cache file?
						// @TODO Rewrite this to a filter
						if (isExtensionActive('cache')) {
							// Remove cache file (will be auto-created again!)
							if ($GLOBALS['cache_instance']->loadCacheFile('config'))    $GLOBALS['cache_instance']->removeCacheFile();
							if ($GLOBALS['cache_instance']->loadCacheFile('extension')) $GLOBALS['cache_instance']->removeCacheFile();
							if ($GLOBALS['cache_instance']->loadCacheFile('modules'))   $GLOBALS['cache_instance']->removeCacheFile();
						} // END - if
					} elseif (getExtensionVersion($ext_name) != '') {
						// Notify the admin that we have a problem here...
						loadTemplate('admin_settings_saved', false, getMessage('ADMIN_REG_FAILED_ALREADY'));
					} else {
						// Notify the admin that we have a problem here...
						loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_REG_FAILED_404'), $ext_name));
					}
				} else {
					// Motify the admin that we have a problem here...
					loadTemplate('admin_settings_saved', false, getMessage('ADMIN_REG_FAILED_DEPRECATED'));
				}
			} else {
				// Extension was not found in task management
				loadTemplate('admin_settings_saved', false, getMessage('ADMIN_REG_FAILED_ID_404'));
			}
		} elseif ($task_found == '0') {
			// No longer assigned or old task
			loadTemplate('admin_settings_saved', false, getMessage('ADMIN_REG_FAILED_ASSIGED'));
		} else {
			// ID is invalid
			loadTemplate('admin_settings_saved', false, getMessage('ADMIN_REG_FAILED_INVALID'));
		}
		break;

	case 'demo':
		loadTemplate('admin_settings_saved', false, getMessage('SETTINGS_NOT_SAVED'));
		break;
}

// [EOF]
?>
